/*
 * BorrowHistory.java
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

import java.rmi.*;
import java.util.*;

public interface BorrowHistory extends Remote {
  public void registerBorrower(BookCard bookCard,
			       User user, 
			       Date checkoutDate,
			       Date returnDate)
                                 throws RemoteException;

  public Date getReturnDate(BookCard bookCard)
                                 throws RemoteException;
                                      
  public User getBorrower(BookCard bookCard)
                                 throws RemoteException;

  public BookCardEnumeration getBorrowedBook()
                                 throws RemoteException;
              
  public BookCardEnumeration getDelayedBook()
                                 throws RemoteException;

  public Date calcReturnDate(Date date)
                                 throws RemoteException;
	      
}
