/*
 * ConnectionDialog.java
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

package schedule;
import java.awt.*;
import java.awt.event.*;
import java.rmi.*;
import java.util.*;

/**
 * ConnectionDialog
 *     RMI ڑw肵A[gIuWFNgI
 * @version    1.1 98/05/07
 * @auther     EMOTO Masahiko, Nihon Sun Microsystems K.K.
 */
class ConnectionDialog extends Dialog{
    TextField fieldHostname;
    TextField fieldUser;
    List listRemoteObjects;
    Button buttonCancel;
    Button buttonOK;
    RemoteSchedule schedule = null;
    RemoteScheduleServer server;
    String scheduleName;
    
    void connectSchedule() {
	String usr = fieldUser.getText();
	scheduleName = usr +"@"+ fieldHostname.getText();
	try {
	    String url =
		"rmi://"+fieldHostname.getText()+
		    "/"+ScheduleServer.URLName;
	    server = (RemoteScheduleServer )Naming.lookup(url);
	    schedule = server.getSchedule(usr);
	} catch (java.net.MalformedURLException ex){
	    ErrorDialog diag =
		new ErrorDialog(this,
				ErrMsg.
				getMsg(ErrMsg.ERR_CONNECT));
	    diag.show();
	    ex.printStackTrace();
	} catch (RemoteException ex){
	    ErrorDialog diag
		= new ErrorDialog(this,
				  ErrMsg.getMsg(ErrMsg.ERR_CONNECT));
	    diag.show();
	    ex.printStackTrace();
	} catch ( NotBoundException ex){
	}
    }
    
    /**
     * zXg͎̏
     *
     */
    class HostnameListener implements ActionListener {
	public HostnameListener(){}
	public void actionPerformed (ActionEvent e){
	    try {
		String url =
		    "rmi://"+fieldHostname.getText()+
			"/"+ScheduleServer.URLName;
		server = (RemoteScheduleServer )Naming.lookup(url);
		Vector list = server.listSchedule();
		listRemoteObjects.removeAll();
		int i;
		for(i=0;i<list.size();i++){
		    listRemoteObjects.addItem((String )list.elementAt(i));
		}
	    } catch ( RemoteException ex){
		ErrorDialog diag =
		    new ErrorDialog(fieldHostname,
				    ErrMsg.getMsg(ErrMsg.ERR_CONNECT));
		diag.show();
		ex.printStackTrace();
	    } catch (java.net.MalformedURLException ex){
		ErrorDialog diag
		    = new ErrorDialog(fieldHostname,
				      ErrMsg.getMsg(ErrMsg.ERR_CONNECT));
		diag.show();
		ex.printStackTrace();
	    } catch ( NotBoundException ex){
	    }
	}
    }
    
    /**
     * [gIuWFNgȈ
     *
     */
    class ListRemoteObjectsListener
	implements ActionListener,MouseListener {
	    public ListRemoteObjectsListener(){}
	    public void actionPerformed(ActionEvent e){
		fieldUser.setText(listRemoteObjects.getSelectedItem());
		connectSchedule();
		setVisible(false);
	    }
	    public void mousePressed(MouseEvent ev){}
	    public void mouseReleased(MouseEvent ev){}
	    public void mouseClicked(MouseEvent ev){
		fieldUser.setText(listRemoteObjects.getSelectedItem());
	    }			
	    public void mouseEntered(MouseEvent ev){}
	    public void mouseExited(MouseEvent ev){}
	}
    
    //Cancel Ă̏
    class ButtonCancelListener implements ActionListener {
	public ButtonCancelListener(){}
	public void actionPerformed(ActionEvent e){
	    schedule = null;
	    setVisible(false);
	}
    }
    
    //OK Ă̏
    class ButtonOKListener implements ActionListener {
	public ButtonOKListener(){}
	public void actionPerformed(ActionEvent e){
	    connectSchedule();
	    setVisible(false);
	}
    }
    
    /**
     * RXgN^
     * @param parent et[
     *
     */
    ConnectionDialog(Frame parent){
	super(parent,true);
	fieldHostname = new TextField(10);
	fieldHostname.addActionListener(new HostnameListener());
	fieldUser = new TextField(20);
	fieldUser.addActionListener(new ButtonOKListener());
	listRemoteObjects = new List(10);
	ListRemoteObjectsListener mouseListener
	    = new ListRemoteObjectsListener();
	listRemoteObjects.addActionListener(mouseListener);
	listRemoteObjects.addMouseListener(mouseListener);
	buttonCancel = new Button("Cancel");
	buttonCancel.addActionListener(new ButtonCancelListener());
	buttonOK = new Button("OK");
	buttonOK.addActionListener(new ButtonOKListener());
	setLayout(new BorderLayout());
	
	Panel p1 = new Panel();
	p1.setLayout(new GridLayout(2,2));
	
	p1.add(new Label("Host:"));
	p1.add(fieldHostname);
	p1.add(new Label("User:"));
	p1.add(fieldUser);
	
	add("North",p1);
	add("Center",listRemoteObjects);
	
	Panel p2 = new Panel();
	p2.add(buttonOK);
	p2.add(buttonCancel);
	
	add("South",p2);
	setSize(400,240);
    }
    
    /**
     * Iꂽ[gIuWFNgԂB
     *
     */
    RemoteSchedule getSchedule(){
	return schedule;
    }
    
    /**
     * IꂽXPW[ԂB([U@zXg)
     *
     */
    String getScheduleName() {
	return scheduleName;
    }

}
