/*
 * DailyScheduleEditor.java
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

package schedule;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.rmi.*;


/**
 * DailyScheduleEditor
 *     1̃XPW[\
 * @version    1.1 98/05/07
 * @auther     EMOTO Masahiko, Nihon Sun Microsystems K.K.
 */
class DailyScheduleEditor extends Canvas {
    AppointEditor appEditor;
    ScheduleEditor editor;
    Vector dailyAppList = null;
    final int HeightHour = 50;
    final int Height = HeightHour * 24;
    final int Width = 300;
    int year = 0;
    int month = 0;
    int date = 0;
    boolean dragging = false;
    int lastY = 0;
    int curY = 0;
    
    /**
     *  }EXCxg̏NX
     */
    class DailyScheduleEditorListener
	implements MouseListener,MouseMotionListener {
	    DailyScheduleEditorListener (){}
	    public void mouseClicked(MouseEvent ev){
		if (appEditor == null ){
		    Component root = getParent();
		    while ( root.getParent() != null
			   && !(root instanceof java.awt.Frame)){
			root = root.getParent();
		    }
		    appEditor = new AppointEditor((Frame )root);
		}
		int h = ev.getY()/HeightHour;
		int m = ev.getY()%HeightHour;
		Appointment ap = null;
		
		if ( dailyAppList != null ){
		    int i; 			// A|Cgǧ
		    for(i=0;i<dailyAppList.size();i++){
			Appointment app = (Appointment )dailyAppList.elementAt(i);
			if ( app.includes(h,m) ){
			    ap = app;
			    break;
			}
		    }
		}else{
		    dailyAppList = new Vector();
		}
		
		if ( ap != null ){ //A|Cg݂B
		    appEditor.editAppointment(dailyAppList,ap);
		    editor.updateDailyAppointments(year,month,date,dailyAppList);
		    repaint();
		}
	    }
	    
	    public void mousePressed(MouseEvent ev){
		lastY = ev.getY();
	    }
	    
	    public void mouseReleased(MouseEvent ev){
		if ( dragging ){
		    /*
		       if ( schedule == null ){
		       ErrorDialog diag =
		       new ErrorDialog(getParent(),
		       ErrMsg.getMsg(ErrMsg.ERR_NOSCHEDULE));
		       diag.show();
		       dragging = false;
		       repaint();
		       return;
		       }
		       */
		    int hs = lastY/HeightHour;
		    int ms = lastY%HeightHour;
		    ms = ms/15*15;
		    int he = curY/HeightHour;
		    int me = curY%HeightHour;
		    me = me/15*15;
		    
		    if (appEditor == null ){
			Component root = getParent();
			while ( root.getParent() != null
			       && !(root instanceof java.awt.Frame)){
			    root = root.getParent();
			}
			appEditor = new AppointEditor((Frame )root);
		    }
		    
		    if ( dailyAppList == null ){
			dailyAppList = new Vector();
		    }
		    
		    if ( (hs*60+ms) < (he*60+me))
			appEditor.registerAppointment(dailyAppList,
						      year,
						      month,
						      date,
						      hs,ms,
						      he,me);
		    else
			appEditor.registerAppointment(dailyAppList,
						      year,
						      month,
						      date,
						      he,me,
						      hs,ms);
		    
		    editor.updateDailyAppointments(year,month,date,dailyAppList);
		    dragging = false;
		    repaint();
		}
	    }
	    
	    public void mouseEntered(MouseEvent ev){}
	    public void mouseExited(MouseEvent ev){}
	    public void mouseDragged(MouseEvent ev){
		dragging = true;
		curY = ev.getY();
		repaint();
	    }
	    public void mouseMoved(MouseEvent ev){}
	}
    
    /**
     * RXgN^
     *
     */
    DailyScheduleEditor(ScheduleEditor e) {
	setSize(Width,Height);
	setVisible(true);
	DailyScheduleEditorListener dailyScheduleEditorListener
	    = new DailyScheduleEditorListener();
	addMouseListener(dailyScheduleEditorListener);
	addMouseMotionListener(dailyScheduleEditorListener);
	dailyAppList = null;
	Calendar today = new GregorianCalendar();
	year = today.get(Calendar.YEAR);
	month = today.get(Calendar.MONTH);
	date = today.get(Calendar.DAY_OF_MONTH);
	editor = e;
	setBackground(Color.white);
    }
    
    /**
     * ҏWΏۂ̃XPW[̕ύX
     *
     */
    void update(){
	show(year,month,date);
    }
    
    /**
     * XPW[̍XV
     *
     */
    void update(Vector v){
	dailyAppList = v;
	repaint();
    }
    
    /**
     *  t y/(m+1)/d ̗\\B
     *
     */
    void show(int y,int m,int d){
	year = y;
	month = m;
	date = d;
	dailyAppList = editor.getDailyAppointments(year,month,date);
	repaint();
    }
    
    public void paint (Graphics g) {
	
	if ( dragging ){
	    int min = HeightHour / 4;
	    int y1 = (lastY/min)*min; // 15 PʂŊۂ߂B
	    int y2 =(curY/min)*min;
	    int y = (y1<y2)?y1:y2;
	    
	    Color c = g.getColor();
	    g.setColor(Color.lightGray);
	    g.fillRect(0, y, Width, Math.abs(y2-y1));
	    g.setColor(c);
	}
	
	Font font = new Font("Monospaced",Font.PLAIN,10);
	g.setFont(font);
	
	int i;
	
	Calendar today = new GregorianCalendar(year,month,date);
	
	
	// A|Cgg̕`
	if ( dailyAppList != null ){
	    for(i=0;i<dailyAppList.size();i++){
		Appointment app;
		app = (Appointment )dailyAppList.elementAt(i);
		int h1 = app.start / 60;
		int m1 = app.start % 60;
		int h2 = app.end / 60;
		int m2 = app.end % 60;
		int y = (int )((h1+m1/60.0)*HeightHour);
		int h = (int )((h2-h1+(m2-m1)/60.0)*HeightHour);
		Color c = g.getColor();
		g.setColor(Color.lightGray);
		g.fillRect(0, y, Width, h);
		g.setColor(c);
		g.drawString(app.description,60,y+h/2);
	    }
	}
	
	// g̕`
	for(i=0;i<24;i++){
	    g.drawRect(0,i*HeightHour,Width,(i+1)*HeightHour);
	    String time = ( i<10 ? "0"+i : ""+i) + ":00";
	    g.drawString(time,10,(int )(HeightHour*(i+0.5)));
	}
	g.drawLine(50,0,50,HeightHour*24);
    }
}
