/*
 * Schedule.java
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

package schedule;

import java.util.*;
import java.io.*;
import java.rmi.server.*;
import java.rmi.*;

/**
 * Schedule
 *     l̃XPW[ǗNX
 * @version    1.1 98/05/07
 * @auther     EMOTO Masahiko, Nihon Sun Microsystems K.K.
 */

public class Schedule extends UnicastRemoteObject
implements RemoteSchedule,Externalizable{
    Hashtable table;
    Hashtable referenced;
    static final String URLName = "Schedule";
    String getKey(int y,int m,int d){
	return ""+y+"/"+m+"/"+d;
    }
    
    public Schedule() throws RemoteException {
	table = new Hashtable();
	referenced = new Hashtable();
    }
    
    
    /**
     *	̃A|CggԂB
     *  @param year  N
     *  @param month 
     *  @param date  
     *  @param editor   Qƌ
     *
     */
    public synchronized Vector getDailyAppointments(int year,
						    int month,
						    int date,
						    RemoteScheduleEditor editor)
	throws RemoteException {
	    
	    String key = getKey(year,month,date);
	    referenced.put(editor,key);	
	    return (Vector )table.get(key);
	}
    
    /**
     * XPW[XV̒ʒm
     *  @param when N̕\
     *  @param list A|Cgg
     *
     */
    private synchronized void notifyAll(String when,Vector list) {
	Enumeration e;
	for(e=referenced.keys();e.hasMoreElements();){
	    RemoteScheduleEditor editor
		= (RemoteScheduleEditor )e.nextElement();
	    String date = (String )referenced.get(editor);
	    if ( date.equals(when)){
		try {
		    editor.notifyScheduleUpdated(list);
		} catch (RemoteException ex){
		    
		}
	    }
	    
	}
    }
    
    /**
     *	A|Cgg̍XV
     *  @param year  N
     *  @param month 
     *  @param date  
     *  @param v     A|Cgg
     *
     */
    public  void updateDailyAppointments(int year,
					 int month,
					 int date,
					 Vector v)
	throws RemoteException {
	    String key = getKey(year,month,date);
	    if ( v.size() == 0 ){
		table.remove(key);
	    }else{
		table.put(key,v);
	    }
	    notifyAll(key,v);
	}
    
    /**
     *  Debug p
     *
     */
    public String toString(){
	Enumeration e;
	String str = "";
	for(e=table.keys();e.hasMoreElements();){
	    String key = (String )e.nextElement();
	    str = str + "[" + key + " ";
	    Vector list = (Vector )table.get(key);
	    for(int i=0;i<list.size();i++){
		Appointment ap = (Appointment )list.elementAt(i);
		str = str + ap.description + " ";
	    }
	    str = str + "]]";
	}
	return str;
    }
    
    /**
     *
     *  Qƃe[u
     *  @param editor QƂĂIuWFNg
     *
     */
    public synchronized void remove(RemoteScheduleEditor editor)
	throws java.rmi.RemoteException {
	    referenced.remove(editor);
	}
    
    /**
     *  Externalizable ̎
     *  @param out  IuWFNgXg[
     *
     */
    public void writeExternal (ObjectOutput out) throws IOException{
	out.writeObject(table);
    }
    
    /**
     *  Externalizable ̎
     *  @param in  IuWFNgXg[
     */
    public void readExternal (ObjectInput in)
	throws IOException,ClassNotFoundException {
	    table = (Hashtable )in.readObject();
	    referenced = new Hashtable();
	}
}
