/*
 * ScheduleServer.java
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

package schedule;
import java.rmi.server.*;
import java.rmi.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;


/**
 * ScheduleServer
 *     XPW[T[oNX
 * @version    1.1 98/05/07
 * @auther     EMOTO Masahiko, Nihon Sun Microsystems K.K.
 */
public class ScheduleServer extends UnicastRemoteObject
implements RemoteScheduleServer {
    Hashtable table;
    String fileName;
    // XPW[T[ogp URL 
    public static final String URLName = "ScheduleServer";
    // Z[ut@C
    final static String DefaultScheduleFile = "ScheduleServer.dat";
    
    /**
     *  Exit ꂽ̏
     *
     *
     */
    class ExitMenuListener implements ActionListener {
	public void actionPerformed (ActionEvent ev ){
	    saveFile();
	    System.exit(0);
	}
    }
    
    /**
     *  Window 鎞̏
     *
     *
     */
    class WindowEventListener implements WindowListener {
	public WindowEventListener(){}
	public void windowActivated(WindowEvent ev){}
	public void windowClosed(WindowEvent ev){}
	public void windowClosing(WindowEvent ev){
	    saveFile();
	    System.exit(0);
	}
	public void windowDeactivated(WindowEvent ev){}
	public void windowDeiconified(WindowEvent ev){}
	public void windowIconified(WindowEvent ev){}
	public void windowOpened(WindowEvent ev){}
    }
    
    ScheduleServer() throws RemoteException{
	table = new Hashtable();
	fileName =null;
    }
    
    ScheduleServer(String s) throws RemoteException{
	table = new Hashtable();
	fileName =s;
    }
    
    /**
     * name Ŏw肳ꂽXPW[Ԃ
     * @param name XPW[
     *
     */
    public RemoteSchedule getSchedule(String name)
	throws RemoteException,MalformedURLException {
	    Schedule schedule = (Schedule)table.get(name);
	    
	    //e[u̒ɑ݂ȂΐVɐ
	    if ( schedule == null ){
		schedule = new Schedule();
		table.put(name,schedule);
		Naming.rebind(Schedule.URLName+"/"+name,schedule);
	    }
	    return schedule;
	}
    
    /**
     * o^ꂽXPW[ꗗԂ
     *
     */
    public Vector listSchedule() throws RemoteException,MalformedURLException {
	Vector list = new Vector();
	Enumeration e;
	
	for(e=table.keys();e.hasMoreElements();){
	    String key = (String )e.nextElement();
	    list.addElement(key);
	}
	return list;
    }
    
    /**
     * ɂSẴXPW[̃oCh
     *
     *
     */
    void rebindAll() throws RemoteException,MalformedURLException{
	Enumeration e;
	
	for(e=table.keys();e.hasMoreElements();){
	    String key = (String )e.nextElement();
	    Schedule schedule = (Schedule )table.get(key);
	    Naming.rebind(key,schedule);
	}
    }
    
    /**
     * SXPW[̃[h
     *
     */
    void loadFile(){
	try {
	    FileInputStream istream = new FileInputStream(fileName);
	    ObjectInputStream p = new ObjectInputStream(istream);
	    table = (Hashtable )p.readObject();
	    istream.close();
	}catch ( FileNotFoundException ex ){
	    return;
	}catch ( IOException ex){
	    ex.printStackTrace();
	    System.exit(-1);
	}catch ( ClassNotFoundException ex){
	    ex.printStackTrace();
	    System.exit(-1);
	}
	
    }
    
    /**
     * SXPW[̃Z[u
     *
     */
    void saveFile(){
	try {
	    FileOutputStream ostream = new FileOutputStream(fileName);
	    ObjectOutputStream p = new ObjectOutputStream(ostream);
	    p.writeObject(table);
	    ostream.close();
	}catch( FileNotFoundException ex ){
	}catch ( IOException ex){
	}
    }
    
    /**
     *   GUI ̏
     */
    public void initGUI(ScheduleServer server){
	Frame frame = new Frame("ScheduleServer");
	MenuBar bar = new MenuBar();
	Menu menuFile = new Menu("File");
	bar.add(menuFile);
	MenuItem menuItemExit = new MenuItem("Exit");
	menuItemExit.addActionListener(new ExitMenuListener());
	menuFile.add(menuItemExit);
	frame.setMenuBar(bar);
	frame.setSize(300,200);
	frame.addWindowListener(new WindowEventListener());
    }

    static public void main(String args[]){
	ScheduleServer scd;
	System.setSecurityManager(new RMISecurityManager());
	try {
	    scd = new ScheduleServer(DefaultScheduleFile);
	    scd.loadFile();
	    scd.rebindAll();
	    Naming.rebind(URLName,scd);
	    ScheduleServerWindow win = new ScheduleServerWindow(scd);
	    win.setVisible(true);
	}catch (java.net.MalformedURLException ex){
	}catch (RemoteException ex){
	    ex.printStackTrace();
	    System.exit(-1);
	}
    }
}
