/*
 * ScheduleServerWindow.java
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

package schedule;
import java.awt.*;
import java.awt.event.*;
import java.io.*;


/**
 * ScheduleServer  GUI 񋟂NX
 *
 * @version    1.1 98/05/07
 * @auther     EMOTO Masahiko, Nihon Sun Microsystems K.K.
 */
class ScheduleServerWindow extends Frame{
    ScheduleServer scheduleServer;
    
    /**
     *  Exit ꂽ̏
     *
     *
     */
    class ExitMenuListener implements ActionListener {
	public void actionPerformed (ActionEvent ev ){
	    scheduleServer.saveFile();
	    System.exit(0);
	}
    }
    
    /**
     *  Window 鎞̏
     *
     *
     */
    class WindowEventListener implements WindowListener {
	public WindowEventListener(){}
	public void windowActivated(WindowEvent ev){}
	public void windowClosed(WindowEvent ev){}
	public void windowClosing(WindowEvent ev){
	    scheduleServer.saveFile();
	    System.exit(0);
	}
	public void windowDeactivated(WindowEvent ev){}
	public void windowDeiconified(WindowEvent ev){}
	public void windowIconified(WindowEvent ev){}
	public void windowOpened(WindowEvent ev){}
    }
    
    public ScheduleServerWindow(ScheduleServer server){
	super("ScheduleServer");
	MenuBar bar = new MenuBar();
	Menu menuFile = new Menu("File");
	bar.add(menuFile);
	MenuItem menuItemExit = new MenuItem("Exit");
	menuItemExit.addActionListener(new ExitMenuListener());
	menuFile.add(menuItemExit);
	setMenuBar(bar);
	setSize(300,200);
	scheduleServer = server;
	addWindowListener(new WindowEventListener());
    }
}
