/*
 * CipherSocket.java
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

import java.io.*;
import java.net.*;

class CipherSocket extends Socket {
    private InputStream in = null;
    private OutputStream out = null;

    public CipherSocket() throws IOException {
	super();
    }

    public CipherSocket(String host,int port) throws IOException {
	super(host,port);
    }

    public InputStream getInputStream() throws IOException {
	if ( in == null ){
	    in = new CipherInputStream(super.getInputStream());
	}
	return in;
    }

    public OutputStream getOutputStream() throws IOException {
	if ( out == null ){
	    out = new CipherOutputStream(super.getOutputStream());
	}
	return out;
    }

}


