/*
 * HelloImpl.java
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

import java.io.*;
import java.rmi.*;
import java.rmi.server.*;

public class HelloImpl
    extends UnicastRemoteObject
    implements Hello
{
    public HelloImpl() throws RemoteException {
	super(0,new SocketType("cipher",null,null));
    }

    /* 
     * Remote method returns String "Hello World!"
     * when invoked.
     */
    public String sayHello() throws RemoteException {
        return  "Hello World!";
    }
  
    public static void main(String args[]) {
      
        // create and install a socket factory

        try {
	    RMISocketFactory.setSocketFactory(new MySocketFactory());
	} catch (IOException e) {
	    System.err.println("HelloImpl: setSocketFactory failed");
	    e.printStackTrace();
	}

	try {
	    HelloImpl obj = new HelloImpl();
	    Naming.rebind("/HelloServer", obj);
	    System.out.println("HelloServer bound in registry");
	} catch (Exception e) {
	    System.out.println("HelloImpl err: " + e.getMessage());
	    e.printStackTrace();
	}
    }
} 
