/*
 * MySocketFactory.java
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

import java.io.*;
import java.net.*;
import java.rmi.*;
import java.rmi.server.*;

public class MySocketFactory extends RMISocketFactory {
    private RMISocketFactory defaultFactory 
        = RMISocketFactory.getDefaultSocketFactory();
   
    public Socket createSocket(String host, int port) throws IOException {
	return defaultFactory.createSocket(host, port);
    }

    public ServerSocket createServerSocket(int port) throws IOException {
	return defaultFactory.createServerSocket(port);
    }

    public Socket createSocket(String host, int port,SocketType type) throws IOException {
	String protocol = type.getProtocol();
	if ( protocol.equals("cipher"))
	    return new CipherSocket(host, port);
	else
	    return defaultFactory.createSocket(host, port);
    }

    public ServerSocket createServerSocket(int port,SocketType type) throws IOException {
	String protocol = type.getProtocol();
	if ( protocol.equals("cipher"))
	    return new CipherServerSocket(port);
	else
	    return defaultFactory.createServerSocket(port);
	
    }

}
